#! /usr/bin/perl -w
#---------------------------------------------------------------
# Project         : Linux-Mandrake
# Module          : bin
# File            : extract_html_images.pl
# Author          : Camille Bgnis
# Created On      : 2002-12-12
# Copyright       : Camille Bgnis <camille@mandrakesoft.com>,
#                    MandrakeSoft under the GPL license
#---------------------------------------------------------------
# This script extracts the image file names used from within a set of 
# HTML files given as arguments on command line
#---------------------------------------------------------------

 

use XML::Twig;

my $usage="
Usage:
extract_html_images.pl <HTML file> ...

";


$ARGV[0] || die $usage;
my $doctype=""; 

foreach my $filename (@ARGV) {
    
    open(FILE, "< $filename") || die "Unknown file: \"$filename\" $!\n";  
    while(<FILE>){ 

	my $line=$_;
	$line=~ s,<img,\n<img,g;
	while ( $line=~ /src=\"images/ ) {
	    $line=~ s,<img [^>]*(src|SRC)=\"(images/[^\"]*)\",,;
	    print "$2\n" if ($2);
	}
    }
}
