#!/bin/bash
#---------------------------------------------------------------
# Project         : Linux-Mandrake
# Module          : bin
# File            : migrate-0.009-0.010.sh
# Author          : Camille Bgnis
# Created On      : 2003-11-26
# Copyright       : Camille Bgnis <camille@mandrakesoft.com>,
#                    MandrakeSoft under the GPL license
#---------------------------------------------------------------
# synopsis: migrate-0.8.3-0.9.0.sh

# This script migrates a Borges repository to conform to 0.10.0 version
# file formats. It notably store modules revision histories in another
# hidden file, and stores the new workflow scheme in repository.xml

LPWD=$(pwd)

if [ "$DISTDIR" != "" ]; then
    export DISTDIR
else
    export DISTDIR=/usr/share/Borges
fi

MANUALS=$($DISTDIR/bin/confparse.pl '//manual' conf/repository.xml)

for m in $MANUALS module; do
    cd $LPWD/manuals/$m
    if [ "$m" == "module" ]; then cp -f conf.xml master.top.xml; fi
    perl -pi -e "s/&/&amp;/g" master.top.xml
    $DISTDIR/utils/migrate-0.009-0.010.pl
    perl -pi -e "s/&amp;/&/g" master.top.xml
done

cd $LPWD

LANGS=$($DISTDIR/bin/confparse.pl '//manual' conf/repository.xml)
for l in $LANGS; do 
    perl -pi -e "s,manuals/module/psgml-top.xml,manuals/module/$l/psgml-top.xml," modules/$l/*.xml
done

cp $DISTDIR/template/conf/author.xml.in conf/author.xml.in

author=$(grep '<initials>' conf/author.xml | sed -e "s,.*initials>\(.*\)<.*,\1,")
language=$(grep '<lang>' conf/author.xml | sed -e "s,.*lang>\(.*\)<.*,\1,")

cp -f conf/author.xml.in conf/author.xml

perl -pi -e "s,<initials>.*</initials>,<initials>$author</initials>," conf/author.xml
perl -pi -e "s,<lang>.*</lang>,<lang>$language</lang>," conf/author.xml

cp $DISTDIR/template/conf/authors.xml conf/authors.xml

perl -pi -e "s,/usr/share/Borges,\$DISTDIR,g" conf/repository.xml

