#!/bin/bash
#---------------------------------------------------------------
# Project         : Borges
# Module          : bin
# File            : migrate-0.012-0.013.sh
# Author          : Camille Bgnis
# Created On      : 2003-11-26
# Copyright       : Camille Bgnis <camille@mandrakesoft.com>,
#                    MandrakeSoft under the GPL license
#---------------------------------------------------------------
# synopsis: migrate-0.012-0.013.sh

# This script migrates a Borges repository to conform to 0.13.0 version
# file formats. It notably make the XSLT processor a parameter to be customized

LPWD=$(pwd)

if [ "$DISTDIR" != "" ]; then
    export DISTDIR
else
    export DISTDIR=/usr/share/Borges
fi

conf=$LPWD/conf/repository.xml

if ! grep '<XSLT>' $conf; then 
    new='<\!-- The XSLT processor command line: \$(1) represents the XSL file, \$(2)
    the XML input, \$(3) the XML output, \$(4) a param=value space
    separated list of parameters -->
    <XSLT>xsltproc \$(if \$(3),-o \$(3)) \$(foreach p,\$(4),--stringparam \$(subst =, ,\$(p))) \$(1) \$(2)</XSLT>
'

    perl -pi -e "s#(\</backend\>)#$new\1#" $conf
fi

if ! grep '<XSLTD>' $LPWD/conf/repository.xml; then 
    new='<\!-- This is the xslt processor specific to documents transformation
    if a different one is needed -->
    <XSLTD>xsltproc \$(if \$(3),-o \$(3)) \$(foreach p,\$(4),--stringparam \$(subst =, ,\$(p))) \$(1) \$(2)</XSLTD>
'

    perl -pi -e "s#(\</backend\>)#$new\1#" $conf
fi


if ! grep '<FO2PDF>' $LPWD/conf/repository.xml; then 
    new='<\!-- The FO processor command line: \$(1) represents the FO file, \$(2)
    the PDF output -->
    <FO2PDF>fop \$(1) \$(2)</FO2PDF>
'

    perl -pi -e "s#(\</backend\>)#$new\1#" $conf
fi
