#!/bin/bash

# initialize dir
rm -rf cvsserver borgescvstest my_doc Reports

# create test CVS server
mkdir cvsserver
cd cvsserver
export CVSROOT=$(pwd)
#echo CVSROOT is $CVSROOT
cvs init
cd ..

# create partial results directory where results of reports
# compilation at different steps will be stored
mkdir -p Reports/{R1,R2,R3,R4,R5,R6,R7,R8,R9}

# The directory where Borges is installed
DMSDIR=/usr/share/Borges

# create template Borges repository
$DMSDIR/bin/configure my_doc
cd my_doc/
make cvsinit PROJECT=borgescvstest
cd ..
cvs co borgescvstest
cd borgescvstest/

# Begin tests
BORGESDIR=$DMSDIR ./configure
make addlang NEWLANG=fr
make addlang NEWLANG=es
echo "TEST S1.1: Adding document Book begins."
make adddoc doc=Book master=/usr/share/Borges/Sample/master.top.xml # REL=1.0
echo "TEST S1.1: Adding document Book ends."
echo "TEST S1.2: Passing write on en/intro-sample-use begins."
make -C modules/en intro-sample-use.revision TYPE=write AUTHOR=cb
echo "TEST S1.2: Passing write on en/intro-sample-use ends."
echo "TEST S1.3: Passing tproof.todo on en/intro-sample-use begins."
make -C modules/en intro-sample-use.revision TYPE=tproof.todo AUTHOR=cb
echo "TEST S1.3: Passing tproof.todo on en/intro-sample-use ends."
echo "TEST S1.4: Compiling reports begins."
make -C reports/ all
#read -p "--------------> Check $(pwd)/reports/index.html then press [enter]"
cp -a reports/* ../Reports/R1/
perl -pi -e "s/..\/reports\///g" ../Reports/R1/index.html
echo "TEST S1.4: Compiling reports ends."
echo "TEST S2.1: Adding document Took begins."
make adddoc doc=Took master=/usr/share/Borges/Sample/master.top.xml REL=1.0
echo "TEST S2.1: Adding document Took ends."
echo "TEST S2.2: Compiling reports begins."
make -C reports/ index.html
#read -p "--------------> Check $(pwd)/reports/index.html then press [enter]"
cp -a reports/* ../Reports/R2/
perl -pi -e "s/..\/reports\///g" ../Reports/R2/index.html
echo "TEST S2.2: Compiling reports ends."
#read -p "--------------> Add some content in modules/en/intro-sample-use.xml, then press [enter]"
cp -f ../intro-sample-use-EN-new.xml modules/en/intro-sample-use.xml
echo "TEST S3.1: Passing revision tproof on en/intro-sample-use begins."
make -C modules/en intro-sample-use.revision TYPE=tproof AUTHOR=cb
echo "TEST S3.1: Passing revision tproof on en/intro-sample-use ends."
echo "TEST S3.2: Passing revision pproof on en/intro-sample-use begins."
make -C modules/en intro-sample-use.revision TYPE=pproof AUTHOR=pp
echo "TEST S3.2: Passing revision pproof on en/intro-sample-use ends."
echo "TEST S3.3: Passing revision translate on fr/intro-sample-use begins."
make -C modules/fr intro-sample-use.revision TYPE=translate AUTHOR=cb
echo "TEST S3.3: Passing revision translate on fr/intro-sample-use ends."
echo "TEST S3.4: Compiling reports begins."
make -C reports/ index.html
#read -p "--------------> Check $(pwd)/reports/index.html then press [enter]"
cp -a reports/* ../Reports/R3/
perl -pi -e "s/..\/reports\///g" ../Reports/R3/index.html
echo "TEST S3.4: Compiling reports ends."
echo "TEST S4.1: Adding release 2.0 begins."
make release NEWREL=2.0
echo "TEST S4.1: Adding release 2.0 ends."
echo "TEST S4.2: Passing update on en/intro-sample-use begins."
make -C modules/en intro-sample-use.revision TYPE=update AUTHOR=pp
echo "TEST S4.2: Passing update on en/intro-sample-use ends."
echo "TEST S4.3: Passing tproof on en/intro-sample-use begins."
make -C modules/en intro-sample-use.revision TYPE=tproof AUTHOR=cb
echo "TEST S4.3: Passing tproof on en/intro-sample-use ends."
echo "TEST S4.4: Passing pproof on en/intro-sample-use begins."
make -C modules/en intro-sample-use.revision TYPE=pproof AUTHOR=cb
echo "TEST S4.4: Passing pproof on en/intro-sample-use ends."
echo "TEST S4.5: Passing ispell on en/intro-sample-use begins."
make -C modules/en intro-sample-use.revision TYPE=ispell AUTHOR=cb
echo "TEST S4.5: Passing ispell on en/intro-sample-use ends."
echo "TEST S4.6: Passing synch on fr/intro-sample-use begins."
cp -f ../intro-sample-use-FR-new.xml modules/fr/intro-sample-use.xml
make -C modules/fr intro-sample-use.revision TYPE=synch AUTHOR=cb
echo "TEST S4.6: Passing synch on fr/intro-sample-use ends."
echo "TEST S4.7: Setting 2.0 start date begins."
make -C manuals/Book/ startwork LANG=en DATE=2004-01-01
make -C manuals/Book/ startwork LANG=fr
make -C manuals/Took/ startwork LANG=en DATE=2004-01-05
make -C manuals/Took/ startwork LANG=fr
make -C manuals/Book/ startwork LANG=es DATE=2004-01-05
make -C manuals/Took/ startwork LANG=es
echo "TEST S4.7: Setting 2.0 start date ends."
echo "TEST S4.8: Compiling reports begins."
make -C reports/ index.html
#read -p "--------------> Check $(pwd)/reports/index.html then press [enter]"
cp -a reports/* ../Reports/R4/
perl -pi -e "s/..\/reports\///g" ../Reports/R4/index.html
echo "TEST S4.8: Compiling reports ends."
echo "TEST S5.1: Passing write on en/intro-sample-whatis begins."
make -C modules/en intro-sample-whatis.revision TYPE=write AUTHOR=cb
echo "TEST S5.1: Passing write on en/intro-sample-whatis ends."
echo "TEST S5.2: Passing tproof on en/intro-sample-whatis begins."
make -C modules/en intro-sample-whatis.revision TYPE=tproof AUTHOR=cb
echo "TEST S5.2: Passing tproof on en/intro-sample-whatis ends."
#read -p "--------------> Add some elements/revisions in modules/en/intro-sample-whatis.xml, then press [enter]"
cp -f ../intro-sample-whatis-EN-new.xml modules/en/intro-sample-whatis.xml
echo "TEST S5.3: Passing pproof on en/intro-sample-whatis begins."
make -C modules/en intro-sample-whatis.revision TYPE=pproof AUTHOR=pp
echo "TEST S5.3: Passing pproof on en/intro-sample-whatis ends."
echo "TEST S5.4: Compiling reports begins."
make -C reports/ index.html
#read -p "--------------> Check $(pwd)/reports/index.html then press [enter]"
cp -a reports/* ../Reports/R5/
perl -pi -e "s/..\/reports\///g" ../Reports/R5/index.html
echo "TEST S5.4: Compiling reports ends."
echo "TEST S6.1: Passing translate.todo on es/intro-sample-use begins."
make -C modules/es intro-sample-use.revision TYPE=translate.todo AUTHOR=pp
echo "TEST S6.1: Passing translate.todo on es/intro-sample-use ends."
echo "TEST S6.2: Compiling mails reports begins."
make -C reports/ mails
#read -p "--------------> Check $(pwd)/reports/*@* then press [enter]"
#read -p "--------------> Check $(pwd)/reports/frontend/index.html then press [enter]"
cp -a reports/* ../Reports/R6/
perl -pi -e "s/..\/reports\///g" ../Reports/R6/index.html
echo "TEST S6.2: Compiling mails reports ends."
echo "TEST S7.1: Compilin accounting reports begins."
make -C reports/ accounting.html
#read -p "--------------> Check $(pwd)/reports/accounting.html"
cp -a reports/* ../Reports/R7/
perl -pi -e "s/..\/reports\///g" ../Reports/R7/index.html
echo "TEST S7.1: Compiling accounting reports ends."
echo "TEST S8.1: Compilng a single module into HTML begins."
make -C manuals/module/ module MOD=intro-sample-whatis FORMAT=html LANG=en
cp -a manuals/module/intro-sample-whatis.html ../Reports/R8/
echo "TEST S8.1: Compiling a single module into HTML ends."
echo "TEST S9.1: Compilng modules list."
cp ../intro-sample-use-EN-new.xml modules/en/
cp ../intro-sample-use-EN.revhistory modules/en/.intro-sample-use-EN-new.revhistory
make -C reports/ modules-list.html
cp -a reports/modules-list.html ../Reports/R9/
rm -f modules/en/intro-sample-use-EN-new.xml
rm -f modules/en/.intro-sample-use-EN-new.revhistory
echo "TEST S9.1: Compiling modules list ends."
#TODO
# Add multilingual doc compilation
# Add document pool and test it
